
/* Declarations of backpropagation algorithm */

#ifndef BACK_H
#define BACK_H	1

#include "defs.h"

char *BackOptStr();
char *BackUsage();
char BackParamStr[256]; 

float NetErr;		/* residual Error */
float LearnRate;	/* learn rate */
float Impulse;		/* impulse constant */
float InitWeight;	/* initial weight range */

/* Arrays */

float **Wih;	/* weight matrix input -> hidden */
float **Who;	/* weight matrix hidden -> output */
float *Hid;	/* hidden states */
float *Out;	/* output states */
float *BiasHid;	/* bias of hidden neurons */
float *BiasOut;	/* bias of output neurons */
float **Dih,**Dho;	/* Weight update (1st order) */
float **DDih,**DDho;	/* Weight update (2nd order) */

/* Procedures */

int handleBackOpt(char opt,char* arg);
int initBack();
void randomNet(float w);
float calcNetErr();
void updateNet();
void printnet();

#endif
