
/* Declaration of Parallel Features */

#ifndef PAR_H
#define PAR_H	1

#include "defs.h"

#define MAXPROCS	16

char *ParOptStr();
char *ParUsage();
char ParParamStr[256]; 

int Procs;	/* no. of processes */
int ProcId;	/* process Id */
int LocalId;	/* Local Id */

int PopGlobal;	/* size of global population */
int PopLocal;	/* size of local population */

int MaxGen;	/* Maximum no. of generations */
errtyp MaxErr;	/* Maximum error for succes */

int SeedRand;	/* random seed */
int Ntrans;	/* frequency of data transfer */

void initNetwork();
int handleParOpt(char opt,char* arg);
int initPar();

void errorexit(char *msg);
void send(int proc,void *p,int len);
void recv(void *p,int len);
int recvfrom(void *p,int len);
void setvect(int n,void *p,int len);
void sendvect(int proc,int n);
void recvvect(int n);
int recvvectfrom(int n);

#endif
